/*optical and acustial spectrum analyzer
 * -calibrated with external reference-
 * -also stolen from learnelectronics       -30.May.2019
 * 
 * 
 * Arduino Spectrum Analizer
 * 
 * learnelectronics
 * 27 April 2017
 * black magic stolen from CBM80Amiga
 * 
 * www.youtube.com/c/learnelectronics
 * arduino1069@gmail.com
 * 
 * Fix_FFT library available @ https://github.com/kosme/arduinoFFT
 */


#include "fix_fft.h"                                  //library to perfom the Fast Fourier Transform

#include <SPI.h>                                      //SPI library
#include <Wire.h>                                     //I2C library for OLED
#include <Adafruit_GFX.h>                             //graphics library for OLED
#include <Adafruit_SSD1306.h>                         //OLED driver

#define OLED_MOSI   9
#define OLED_CLK   10
#define OLED_DC    11
#define OLED_CS    12
#define OLED_RESET 13
Adafruit_SSD1306 display(OLED_MOSI, OLED_CLK, OLED_DC, OLED_RESET, OLED_CS);



char im[128], data[128];                              //variables for the FFT
char x = 0, ylim = 60;                                //variables for drawing the graphics
int i = 0, val, amp,maxf=0,f,min,max;                                       //counters

void setup()
{
  Serial.begin(115200);                                 //serial comms for debuging
  display.setRotation(2);
  display.begin(SSD1306_SWITCHCAPVCC);
  // init done
  
  // Show image buffer on the display hardware.
  // Since the buffer is intialized with an Adafruit splashscreen
  // internally, this will display the splashscreen.
  display.display();
  delay(2000);
  
  display.setTextSize(1);                             //set OLED text size to 1 (1-6)
  display.setTextColor(WHITE);                        //set text color to white
  display.clearDisplay();                             //clear display
  
  analogReference(DEFAULT);                           // Use default (5v) aref voltage.
  amp=map(analogRead(A1),0,1024,0,100);
};

void loop()
{
  amp=60;  //map(analogRead(A1),0,1024,0,80);
//  int min=1024, max=0;                                //set minumum & maximum ADC values
  for (i = 0; i < 128; i++) {                         //take 128 samples
    val = amp*(analogRead(A0)-400);                             //get audio from Analog 0
    data[i] = val / 4 - 128;       //each element of array is val/4-128

delay(5);
    
    im[i] = 0;                                        //
//    if(val>max) max=val;                              //capture maximum level
 //   if(val<min) min=val;                              //capture minimum level
  };
    
  fix_fft(data, im, 7, 0);                            //perform the FFT on data
  
  display.clearDisplay();                             //clear display
  maxf=0;
  for (i = 1; i < 64; i++) 
  {                          // In the current design, 60Hz and noise
    int dat = sqrt(data[i] * data[i] + im[i] * im[i]);//filter out noise and hum
    display.drawLine(i*2 + x, ylim, i*2 + x, ylim - dat, WHITE); // draw bar graphics for freqs above 500Hz to buffer
    if (dat > maxf)
    {
      maxf=dat;
      f=i;
      

     }
  }
  f = (map(f,0,64,520,5000))-510;                           
  display.setCursor(0,0);                             //set cursor to top of screen
  display.println("--Spectrum-Analyzer--");
  display.setCursor(0,10);                            //set cursor to top of screen
  display.print("f0: ");
  display.print(f);             //print title to buffer
//  display.print("max: ");
//display.print(f);  
  display.display();                                  //show the buffer
  f=0;
};
